<?php
/**
 * $Horde: whups/clearsearch.php,v 1.7 2006/01/01 21:12:12 jan Exp $
 *
 * Copyright 2001-2006 Robert E. Coyle <robertecoyle@hotmail.com>
 * Copyright 2001-2006 Chuck Hagenbuch <chuck@horde.or>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';

if (!Auth::getAuth()) {
    header('Location: ' . Horde::applicationUrl('search.php', true));
    exit;
}

$clear = Util::getFormData('clear');
$search = Util::getFormData('search');

if ($clear) {
    // Clear searches for the current user.
    if ($search) {
        $whups->clearUserSearches(Auth::getAuth(), $search);
        $msg = _("Search cleared.");
    } else {
        $whups->clearUserSearches(Auth::getAuth());
        $msg = _("Searches cleared.");
    }
    $notification->push($msg, 'horde.success');
} else {
    $notification->push(_("No searches cleared."), 'horde.message');
}

/* Return to the previous page. */
$url = Util::getFormData('url');
if ($url) {
    header('Location: ' . $url);
} else {
    header('Location: ' . Horde::applicationUrl('mybugs.php', true));
}
