<?php

$block_name = _("My Queries");

/**
 * Horde_Block_Whups_myqueries:: Implementation of the Horde_Block API
 * to show the current user's queries.
 *
 * $Horde: whups/lib/Block/myqueries.php,v 1.9 2006/01/02 18:19:17 jan Exp $
 *
 * @package Horde_Block
 */
class Horde_Block_Whups_myqueries extends Horde_Block {

    var $_app = 'whups';

    /**
     * The title to go in this block.
     *
     * @return string   The title text.
     */
    function _title()
    {
        global $registry;

        return _("My Queries") . ' :: <small>' .
            Horde::link(Horde::applicationUrl('query.php', true)) .
            Horde::img('query.png', _("New Query")) . _("New Query") . '</a></small>';
    }

    /**
     * The content to go in this block.
     *
     * @return string   The content
     */
    function _content()
    {
        require_once dirname(__FILE__) . '/../base.php';
        require_once WHUPS_BASE . '/lib/Query.php';
        require_once WHUPS_TEMPLATES . '/savedqueries.inc';
        global $whups;

        $myqueries = &new SavedQueries();
        $qManager = &Whups_QueryManager::singleton();
        return '<table cellspacing="0" width="100%">' .
            Util::bufferOutput(array($myqueries, 'results'), $qManager->listShares(Auth::getAuth())) .
            '</table>';
    }

}
