-- $Horde: whups/scripts/upgrades/2004-04-08_create_queues.pgsql.sql,v 1.1 2004/09/18 20:19:02 chuck Exp $

-- Change fields named module_id in tables that aren't migrating
-- wholesale.
ALTER TABLE whups_versions RENAME module_id TO queue_id;
ALTER TABLE whups_tickets RENAME module_id TO queue_id;

-- For client links.
UPDATE horde_datatree_attributes SET attribute_value = 'queue_id' WHERE attribute_value = 'module_id';

CREATE TABLE whups_queues (
    queue_id            INT NOT NULL,
    queue_name          VARCHAR(64) NOT NULL,
    queue_description   VARCHAR(255),
    queue_subjectlist   SMALLINT DEFAULT 0 NOT NULL,
    queue_versioned     SMALLINT DEFAULT 0 NOT NULL,
    queue_allclients    SMALLINT DEFAULT 0 NOT NULL,

    PRIMARY KEY (queue_id)
);

CREATE TABLE whups_queues_users (
    queue_id            INT NOT NULL,
    user_uid            VARCHAR(250) NOT NULL,

    PRIMARY KEY (queue_id, user_uid)
);

CREATE TABLE whups_queues_subjects (
    queue_id            INT NOT NULL,
    subject_id          INT NOT NULL,

    PRIMARY KEY (queue_id, subject_id)
);

CREATE TABLE whups_types_queues (
    type_id             INT NOT NULL,
    queue_id            INT NOT NULL
);

GRANT SELECT, INSERT, UPDATE, DELETE ON whups_queues TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON whups_queues_users TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON whups_queues_subjects TO horde;
GRANT SELECT, INSERT, UPDATE, DELETE ON whups_types_queues TO horde;
