<?php
/**
 * $Horde: whups/ticket/create.php,v 1.13 2006/01/01 21:12:16 jan Exp $
 *
 * Copyright 2001-2006 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('WHUPS_BASE', dirname(__FILE__) . '/..');
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Create.php';
require_once WHUPS_BASE . '/lib/Ticket.php';
require_once 'Horde/Variables.php';

$RENDERER = &new Horde_Form_Renderer();

$empty = '';
$beendone = 0;
$wereerrors = 0;

$vars = &Variables::getDefaultVariables($empty);
$formname = $vars->get('formname');

// Start the page.
$title = _("New Ticket");

$form1 = &Horde_Form::singleton('CreateStep1Form', $vars);
$form2 = &Horde_Form::singleton('CreateStep2Form', $vars);
$form3 = &Horde_Form::singleton('CreateStep3Form', $vars);
$form4 = &Horde_Form::singleton('CreateStep4Form', $vars);

$valid4 = $form4->validate($vars) && $vars->get('formname') == 'createstep4form';
$valid3 = $form3->validate($vars, true);
$valid2 = $form2->validate($vars, true);
$valid1 = $form1->validate($vars, true);

if (!$valid3 ||
    !$valid2 ||
    !$valid1 ||
    (Auth::getAuth() && $whups->isCategory('assigned', $vars->get('state')) && !$valid4)) {
    require WHUPS_TEMPLATES . '/common-header.inc';
    require WHUPS_TEMPLATES . '/menu.inc';

    if ($valid3 && $valid2 && $valid1) {
        $form4->open($RENDERER, $vars, 'create.php', 'post');

        // Preserve previous forms.
        $form1->preserve($vars);
        $RENDERER->beginInactive($form1->getTitle());
        $RENDERER->renderFormInactive($form1, $vars);
        $RENDERER->end();
        echo '<br />';

        $form2->preserve($vars);
        $RENDERER->beginInactive($form2->getTitle());
        $RENDERER->renderFormInactive($form2, $vars);
        $RENDERER->end();
        echo '<br />';

        $form3->preserve($vars);
        $RENDERER->beginInactive($form3->getTitle());
        $RENDERER->renderFormInactive($form3, $vars);
        $RENDERER->end();
        echo '<br />';

        // Render the 4th stage form.
        if ($formname != 'createstep4form') {
            $form4->clearValidation();
        }
        $RENDERER->beginActive($form4->getTitle());
        $RENDERER->renderFormActive($form4, $vars);
        $RENDERER->submit();
        $RENDERER->end();
        $form3->close($RENDERER);

        $beendone = 1;
    } elseif ($valid2 && $valid1) {
        $form3->open($RENDERER, $vars, 'create.php', 'post');

        // Render the stage 1 form readonly.
        $form1->preserve($vars);
        $RENDERER->beginInactive($form1->getTitle());
        $RENDERER->renderFormInactive($form1, $vars);
        $RENDERER->end();
        echo '<br />';

        // Render the stage 2 form readonly.
        $form2->preserve($vars);
        $RENDERER->beginInactive($form2->getTitle());
        $RENDERER->renderFormInactive($form2, $vars);
        $RENDERER->end();
        echo '<br />';

        // Render the third stage form.
        if ($formname != 'createstep3form') {
            $form3->clearValidation();
        }
        $RENDERER->beginActive($form3->getTitle());
        $RENDERER->renderFormActive($form3, $vars);
        $RENDERER->submit(_("Submit"), true);
        $RENDERER->end();

        $form3->close($RENDERER);

        $beendone = 1;
    } else {
        if ($valid1) {
            $form2->open($RENDERER, $vars, 'create.php', 'post');

            // Render the original form readonly.
            $form1->preserve($vars);
            $RENDERER->beginInactive($form1->getTitle());
            $RENDERER->renderFormInactive($form1, $vars);
            $RENDERER->end();
            echo '<br />';

            // Render the second stage form.
            if ($formname != 'createstep2form') {
                $form2->clearValidation();
            }
            $RENDERER->beginActive($form2->getTitle());
            $RENDERER->renderFormActive($form2, $vars);
            $RENDERER->submit();
            $RENDERER->end();

            $form2->close($RENDERER);

            $beendone = 1;
        } else {
            if ($formname != 'createstep1form') {
                $form1->clearValidation();
            }
            $form1->open($RENDERER, $vars, 'create.php', 'post');
            $RENDERER->beginActive($form1->getTitle());
            $RENDERER->renderFormActive($form1, $vars);
            $RENDERER->submit();
            $RENDERER->end();
            $form1->close($RENDERER);
        }
    }
} else {
    $form1->getInfo($vars, $info);
    $form2->getInfo($vars, $info);
    $form3->getInfo($vars, $info);
    if (Auth::getAuth() && $whups->isCategory('assigned', $vars->get('state'))) {
        $form4->getInfo($vars, $info);
    }

    $ticket = &Whups_Ticket::newTicket($info, Auth::getAuth());
    if (is_a($ticket, 'PEAR_Error')) {
        Horde::logMessage($ticket, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(sprintf(_("Adding your ticket failed: %s."), $ticket->getMessage()), 'horde.error');
        header('Location: ' . Horde::applicationUrl('ticket/create.php', true));
    } else {
        $notification->push(sprintf(_("Your ticket ID is %s. An appropriate person has been notified of this request."), $ticket->getId()), 'horde.success');
        header('Location: ' . Util::addParameter(Horde::applicationUrl('ticket/', true), 'id', $ticket->getId(), false));
    }
    exit;
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
